package com.zerohighdef.hush;

import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

public class WatchCategory {
    private final String categoryName;
    private final List<Pattern> patterns;
    private final List<String> commands;

    public WatchCategory(String categoryName, List<String> patterns, List<String> commands) {
        this.categoryName = categoryName;
        this.patterns = buildPattern(patterns);
        this.commands = commands;
    }

    private static List<Pattern> buildPattern(List<String> patternList) {
        return patternList
                .stream()
                .map(p -> Pattern.compile(String.format("(%s)", p)))
                .collect(Collectors.toList());
    }

    public Matcher checkPatterns(String string) {
        for (Pattern p: patterns) {
            Matcher matcher = p.matcher(string);

            if (matcher.find()) {
                return matcher;
            }
        }

        return null;
    }

    public String getCategoryName() {
        return categoryName;
    }

    public List<String> getCommands() {
        return commands;
    }
}
